<xsl:stylesheet version="1.1"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:output method="xml" version="1.0" encoding="iso-8859-1" indent="yes" />
	<xsl:template match="/" xmlns:b="DEFAULT_XMLNS">
		<xsl:param name="ns1"/>
		<xsl:for-each select="b:KNX/b:Project/b:Installations/b:Installation/b:Topology">
			<datapoints>
				<xsl:for-each select="b:Area/b:Line/b:DeviceInstance">
					<xsl:choose>
						<xsl:when test="matches(@ProductRefId, 'M-00C5_H-KNX.20BAOS.*_P-KNX.20BAOS.2082.*87.*')">
<!--
												  M-00C5_H-KNX.20BAOS.2082x.2087x-1_P-KNX.20BAOS.2082x.2087x
 							test="@ProductRefId= 'M-00C5_H-KNX.20BAOS.20Serial.20820.2F870-1_P-KNX.20BAOS.20820.2F870'">
 -->							<xsl:for-each
								select="b:ComObjectInstanceRefs/b:ComObjectInstanceRef/b:Connectors">
								<xsl:variable name="verz"
									select="document(concat(substring(../@RefId,0,7),'/',substring-before(../@RefId, '_O'), '.xml'))/b:KNX/b:ManufacturerData/b:Manufacturer/b:ApplicationPrograms/b:ApplicationProgram/b:Static/b:ComObjectTable/b:ComObject[@Id = ../../b:ComObjectRefs/b:ComObjectRef[@Id = current()/../@RefId]/@RefId]" />
								<xsl:variable name="grosse">
									<xsl:choose>
										<xsl:when test="substring-after($verz/@ObjectSize,' ') = 'Bytes'">
											<xsl:value-of select="substring-before($verz/@ObjectSize,' ')*8" />
										</xsl:when>
										<xsl:otherwise>
											<xsl:value-of select="substring-before($verz/@ObjectSize,' ')" />
										</xsl:otherwise>
									</xsl:choose>
								</xsl:variable>
								<xsl:variable name="master"
									select="document('knx_master.xml')/b:KNX/b:MasterData/b:DatapointTypes/b:DatapointType[@SizeInBit = $grosse]" />
								<xsl:variable name="master2"
									select="document('knx_master.xml')/b:KNX/b:MasterData/b:DatapointTypes/b:DatapointType/b:DatapointSubtypes/b:DatapointSubtype[@Id = current()/../@DatapointType]" />
								<xsl:variable name="master3"
									select="document('knx_master.xml')/b:KNX/b:MasterData/b:DatapointTypes/b:DatapointType[@Id = current()/../@DatapointType]" />
								<xsl:variable name="graddress"
									select="/b:KNX/b:Project/b:Installations/b:Installation/b:GroupAddresses/b:GroupRanges/b:GroupRange/b:GroupRange" />
								<datapoint>
									<xsl:attribute name="name">
        <xsl:value-of select="$verz/@Name" />
		</xsl:attribute>
									<xsl:attribute name="groupName">
	<xsl:for-each select="b:Send">
			<knxAddress type="group">
 				<xsl:value-of
										select="$graddress/b:GroupAddress[@Id = current()/@GroupAddressRefId]/@Name" />
			</knxAddress>
  	</xsl:for-each>
	</xsl:attribute>
									<xsl:attribute name="mainNumber">
		<xsl:choose>
		<xsl:when test="../@DatapointType != ''">
			<xsl:choose>
			<xsl:when test="string-length(../@DatapointType) > 5">
				<xsl:value-of select="$master2/../../@Number" />
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$master3/@Number" />
			</xsl:otherwise>
			</xsl:choose>
		</xsl:when>
		<xsl:otherwise>
			<xsl:value-of select="$master/@Number" />
		</xsl:otherwise>
		</xsl:choose>
	</xsl:attribute>
									<xsl:attribute name="dptID">
		<xsl:choose>
		<xsl:when test="../@DatapointType != ''">
			<xsl:choose>
			<xsl:when test="string-length(../@DatapointType) > 5">
				<xsl:value-of
										select="concat($master2/../../@Number, '.',format-number($master2/@Number, '000') )" />
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="concat($master3/@Number, '.001')" />
			</xsl:otherwise>
			</xsl:choose>
		</xsl:when>
		<xsl:otherwise>
			<xsl:value-of
										select="concat($master/@Number,'.',format-number($master/b:DatapointSubtypes/b:DatapointSubtype/@Number, '000'))" />
		</xsl:otherwise>
		</xsl:choose>
	</xsl:attribute>

									<xsl:for-each select="b:Send">
										<knxAddress>
											<xsl:value-of
												select="$graddress/b:GroupAddress[@Id = current()/@GroupAddressRefId]/@Address" />
										</knxAddress>
									</xsl:for-each>
									<xsl:choose>
										<xsl:when test="b:Receive">
											<xsl:for-each select="b:Receive">
												<updatingAddresses>
													<xsl:value-of
														select="$graddress/b:GroupAddress[@Id = current()/@GroupAddressRefId]/@Address" />
												</updatingAddresses>
											</xsl:for-each>
										</xsl:when>
									</xsl:choose>
								</datapoint>
							</xsl:for-each>
						</xsl:when>
					</xsl:choose>
				</xsl:for-each>
			</datapoints>
		</xsl:for-each>
	</xsl:template>
</xsl:stylesheet>
